diff --git a/web/pgadmin/utils/sqlautocomplete/autocomplete.py b/web/pgadmin/utils/sqlautocomplete/autocomplete.py
index 8a25c13..3efac77 100644
--- a/web/pgadmin/utils/sqlautocomplete/autocomplete.py
+++ b/web/pgadmin/utils/sqlautocomplete/autocomplete.py
@@ -262,119 +493,383 @@ class SQLAutoComplete(object):
 
         result = dict()
         for m in matches:
-            # Escape name only if meta type is not a keyword and datatype.
-            if m.completion.display_meta != 'keyword' and \
-                    m.completion.display_meta != 'datatype':
-                name = self.escape_name(m.completion.display)
-            else:
-                name = m.completion.display
-
+            name = m.completion.display
             result[name] = {'object_type': m.completion.display_meta}
 
         return result
 
     def get_column_matches(self, suggestion, word_before_cursor):
-        tables = suggestion.tables
-        scoped_cols = self.populate_scoped_cols(tables)
-
-        if suggestion.drop_unique:
-            # drop_unique is used for 'tb11 JOIN tbl2 USING (...' which should
-            # suggest only columns that appear in more than one table
-            scoped_cols = [col for (col, count)
-                           in Counter(scoped_cols).items()
-                           if count > 1 and col != '*']
-
-        return self.find_matches(
-            word_before_cursor, scoped_cols, mode='strict', meta='column'
+
+        # Tables and Views should be populated first.
+        self.fetch_schema_objects(None, 'tables')
+        self.fetch_schema_objects(None, 'views')
+
+        tables = suggestion.table_refs
+        do_qualify = suggestion.qualifiable and {
+            'always': True, 'never': False,
+            'if_more_than_one_table': len(tables) > 1}[self.qualify_columns]
+
+        def qualify(col, tbl):
+            return (tbl + '.' + col) if do_qualify else col
+
+        scoped_cols = self.populate_scoped_cols(
+            tables, suggestion.local_tables
         )
 
-    def get_function_matches(self, suggestion, word_before_cursor):
-        if suggestion.filter == 'is_set_returning':
-            # Only suggest set-returning functions
-            funcs = self.populate_functions(suggestion.schema)
+        def make_cand(name, ref):
+            synonyms = (name, generate_alias(name))
+            return Candidate(qualify(name, ref), 0, 'column', synonyms)
+
+        def flat_cols():
+            return [make_cand(c.name, t.ref) for t, cols in scoped_cols.items()
+                    for c in cols]
+        if suggestion.require_last_table:
+            # require_last_table is used for 'tb11 JOIN tbl2 USING
+            # (...' which should
+            # suggest only columns that appear in the last table and one more
+            ltbl = tables[-1].ref
+            other_tbl_cols = set(
+                c.name for t, cs in scoped_cols.items() if t.ref != ltbl
+                for c in cs
+            )
+            scoped_cols = {
+                t: [col for col in cols if col.name in other_tbl_cols]
+                for t, cols in scoped_cols.items()
+                if t.ref == ltbl
+            }
+        lastword = last_word(word_before_cursor, include='most_punctuations')
+        if lastword == '*':
+            if suggestion.context == 'insert':
+                def filter(col):
+                    if not col.has_default:
+                        return True
+                    return not any(
+                        p.match(col.default)
+                        for p in self.insert_col_skip_patterns
+                    )
+                scoped_cols = {
+                    t: [col for col in cols if filter(col)]
+                    for t, cols in scoped_cols.items()
+                }
+            if self.asterisk_column_order == 'alphabetic':
+                for cols in scoped_cols.values():
+                    cols.sort(key=operator.attrgetter('name'))
+            if (
+                lastword != word_before_cursor and
+                len(tables) == 1 and
+                word_before_cursor[-len(lastword) - 1] == '.'
+            ):
+                # User typed x.*; replicate "x." for all columns except the
+                # first, which gets the original (as we only replace the "*"")
+                sep = ', ' + word_before_cursor[:-1]
+                collist = sep.join(c.completion for c in flat_cols())
+            else:
+                collist = ', '.join(qualify(c.name, t.ref)
+                                    for t, cs in scoped_cols.items()
+                                    for c in cs)
+
+            return [Match(
+                completion=Completion(
+                    collist,
+                    -1,
+                    display_meta='columns',
+                    display='*'
+                ),
+                priority=(1, 1, 1)
+            )]
+
+        return self.find_matches(word_before_cursor, flat_cols(),
+                                 mode='strict', meta='column')
+
+    def alias(self, tbl, tbls):
+        """ Generate a unique table alias
+        tbl - name of the table to alias, quoted if it needs to be
+        tbls - TableReference iterable of tables already in query
+        """
+        tbls = set(normalize_ref(t.ref) for t in tbls)
+        if self.generate_aliases:
+            tbl = generate_alias(self.unescape_name(tbl))
+        if normalize_ref(tbl) not in tbls:
+            return tbl
+        elif tbl[0] == '"':
+            aliases = ('"' + tbl[1:-1] + str(i) + '"' for i in count(2))
+        else:
+            aliases = (tbl + str(i) for i in count(2))
+        return next(a for a in aliases if normalize_ref(a) not in tbls)
+
+    def get_join_matches(self, suggestion, word_before_cursor):
+        tbls = suggestion.table_refs
+        cols = self.populate_scoped_cols(tbls)
+        # Set up some data structures for efficient access
+        qualified = dict((normalize_ref(t.ref), t.schema) for t in tbls)
+        ref_prio = dict((normalize_ref(t.ref), n) for n, t in enumerate(tbls))
+        refs = set(normalize_ref(t.ref) for t in tbls)
+        other_tbls = set((t.schema, t.name) for t in list(cols)[:-1])
+        joins = []
+        # Iterate over FKs in existing tables to find potential joins
+        fks = (
+            (fk, rtbl, rcol) for rtbl, rcols in cols.items()
+            for rcol in rcols for fk in rcol.foreignkeys
+        )
+        col = namedtuple('col', 'schema tbl col')
+        for fk, rtbl, rcol in fks:
+            right = col(rtbl.schema, rtbl.name, rcol.name)
+            child = col(fk.childschema, fk.childtable, fk.childcolumn)
+            parent = col(fk.parentschema, fk.parenttable, fk.parentcolumn)
+            left = child if parent == right else parent
+            if suggestion.schema and left.schema != suggestion.schema:
+                continue
+            if self.generate_aliases or normalize_ref(left.tbl) in refs:
+                lref = self.alias(left.tbl, suggestion.table_refs)
+                join = '{0} {4} ON {4}.{1} = {2}.{3}'.format(
+                    left.tbl, left.col, rtbl.ref, right.col, lref)
+            else:
+                join = '{0} ON {0}.{1} = {2}.{3}'.format(
+                    left.tbl, left.col, rtbl.ref, right.col)
+            alias = generate_alias(left.tbl)
+            synonyms = [join, '{0} ON {0}.{1} = {2}.{3}'.format(
+                alias, left.col, rtbl.ref, right.col)]
+            # Schema-qualify if (1) new table in same schema as old, and old
+            # is schema-qualified, or (2) new in other schema, except public
+            if not suggestion.schema and \
+                (qualified[normalize_ref(rtbl.ref)] and
+                 left.schema == right.schema or
+                 left.schema not in(right.schema, 'public')):
+                join = left.schema + '.' + join
+            prio = ref_prio[normalize_ref(rtbl.ref)] * 2 + (
+                0 if (left.schema, left.tbl) in other_tbls else 1)
+            joins.append(Candidate(join, prio, 'join', synonyms=synonyms))
+
+        return self.find_matches(word_before_cursor, joins,
+                                 mode='strict', meta='join')
+
+    def get_join_condition_matches(self, suggestion, word_before_cursor):
+        col = namedtuple('col', 'schema tbl col')
+        tbls = self.populate_scoped_cols(suggestion.table_refs).items
+        cols = [(t, c) for t, cs in tbls() for c in cs]
+        try:
+            lref = (suggestion.parent or suggestion.table_refs[-1]).ref
+            ltbl, lcols = [(t, cs) for (t, cs) in tbls() if t.ref == lref][-1]
+        except IndexError:  # The user typed an incorrect table qualifier
+            return []
+        conds, found_conds = [], set()
+
+        def add_cond(lcol, rcol, rref, prio, meta):
+            prefix = '' if suggestion.parent else ltbl.ref + '.'
+            cond = prefix + lcol + ' = ' + rref + '.' + rcol
+            if cond not in found_conds:
+                found_conds.add(cond)
+                conds.append(Candidate(cond, prio + ref_prio[rref], meta))
+
+        def list_dict(pairs):  # Turns [(a, b), (a, c)] into {a: [b, c]}
+            d = defaultdict(list)
+            for pair in pairs:
+                d[pair[0]].append(pair[1])
+            return d
+
+        # Tables that are closer to the cursor get higher prio
+        ref_prio = dict((tbl.ref, num)
+                        for num, tbl in enumerate(suggestion.table_refs))
+        # Map (schema, table, col) to tables
+        coldict = list_dict(
+            ((t.schema, t.name, c.name), t) for t, c in cols if t.ref != lref
+        )
+        # For each fk from the left table, generate a join condition if
+        # the other table is also in the scope
+        fks = ((fk, lcol.name) for lcol in lcols for fk in lcol.foreignkeys)
+        for fk, lcol in fks:
+            left = col(ltbl.schema, ltbl.name, lcol)
+            child = col(fk.childschema, fk.childtable, fk.childcolumn)
+            par = col(fk.parentschema, fk.parenttable, fk.parentcolumn)
+            left, right = (child, par) if left == child else (par, child)
+            for rtbl in coldict[right]:
+                add_cond(left.col, right.col, rtbl.ref, 2000, 'fk join')
+        # For name matching, use a {(colname, coltype): TableReference} dict
+        coltyp = namedtuple('coltyp', 'name datatype')
+        col_table = list_dict((coltyp(c.name, c.datatype), t) for t, c in cols)
+        # Find all name-match join conditions
+        for c in (coltyp(c.name, c.datatype) for c in lcols):
+            for rtbl in (t for t in col_table[c] if t.ref != ltbl.ref):
+                prio = 1000 if c.datatype in (
+                    'integer', 'bigint', 'smallint') else 0
+                add_cond(c.name, c.name, rtbl.ref, prio, 'name join')
+
+        return self.find_matches(word_before_cursor, conds,
+                                 mode='strict', meta='join')
+
+    def get_function_matches(self, suggestion, word_before_cursor,
+                             alias=False):
+        if suggestion.usage == 'from':
+            # Only suggest functions allowed in FROM clause
+            def filt(f):
+                return not f.is_aggregate and not f.is_window
         else:
-            funcs = self.populate_schema_objects(
-                suggestion.schema, 'functions')
+            alias = False
 
+            def filt(f):
+                return True
+
+        arg_mode = {
+            'signature': 'signature',
+            'special': None,
+        }.get(suggestion.usage, 'call')
         # Function overloading means we way have multiple functions of the same
         # name at this point, so keep unique names only
-        funcs = set(funcs)
-
-        funcs = self.find_matches(
-            word_before_cursor, funcs, mode='strict', meta='function')
+        funcs = set(
+            self._make_cand(f, alias, suggestion, arg_mode)
+            for f in self.populate_functions(suggestion.schema, filt)
+        )
 
-        return funcs
+        matches = self.find_matches(word_before_cursor, funcs,
+                                    mode='strict', meta='function')
 
-    def get_schema_matches(self, _, word_before_cursor):
-        schema_names = []
+        return matches
 
-        query = render_template("/".join([self.sql_path, 'schema.sql']))
-        status, res = self.conn.execute_dict(query)
-        if status:
-            for record in res['rows']:
-                schema_names.append(record['schema'])
+    def get_schema_matches(self, suggestion, word_before_cursor):
+        schema_names = self.dbmetadata['tables'].keys()
 
         # Unless we're sure the user really wants them, hide schema names
         # starting with pg_, which are mostly temporary schemas
         if not word_before_cursor.startswith('pg_'):
-            schema_names = [s for s in schema_names if not s.startswith('pg_')]
+            schema_names = [s
+                            for s in schema_names
+                            if not s.startswith('pg_')]
+
+        if suggestion.quoted:
+            schema_names = [self.escape_schema(s) for s in schema_names]
+
+        return self.find_matches(word_before_cursor, schema_names,
+                                 mode='strict', meta='schema')
+
+    def get_from_clause_item_matches(self, suggestion, word_before_cursor):
+        alias = self.generate_aliases
+        s = suggestion
+        t_sug = Table(s.schema, s.table_refs, s.local_tables)
+        v_sug = View(s.schema, s.table_refs)
+        f_sug = Function(s.schema, s.table_refs, usage='from')
+        return (
+            self.get_table_matches(t_sug, word_before_cursor, alias) +
+            self.get_view_matches(v_sug, word_before_cursor, alias) +
+            self.get_function_matches(f_sug, word_before_cursor, alias)
+        )
 
-        return self.find_matches(
-            word_before_cursor, schema_names, mode='strict', meta='schema'
+    def _arg_list(self, func, usage):
+        """Returns a an arg list string, e.g. `(_foo:=23)` for a func.
+
+        :param func is a FunctionMetadata object
+        :param usage is 'call', 'call_display' or 'signature'
+
+        """
+        template = {
+            'call': self.call_arg_style,
+            'call_display': self.call_arg_display_style,
+            'signature': self.signature_arg_style
+        }[usage]
+        args = func.args()
+        if not template:
+            return '()'
+        elif usage == 'call' and len(args) < 2:
+            return '()'
+        elif usage == 'call' and func.has_variadic():
+            return '()'
+        multiline = usage == 'call' and len(args) > self.call_arg_oneliner_max
+        max_arg_len = max(len(a.name) for a in args) if multiline else 0
+        args = (
+            self._format_arg(template, arg, arg_num + 1, max_arg_len)
+            for arg_num, arg in enumerate(args)
+        )
+        if multiline:
+            return '(' + ','.join('\n    ' + a for a in args if a) + '\n)'
+        else:
+            return '(' + ', '.join(a for a in args if a) + ')'
+
+    def _format_arg(self, template, arg, arg_num, max_arg_len):
+        if not template:
+            return None
+        if arg.has_default:
+            arg_default = 'NULL' if arg.default is None else arg.default
+            # Remove trailing ::(schema.)type
+            arg_default = arg_default_type_strip_regex.sub('', arg_default)
+        else:
+            arg_default = ''
+        return template.format(
+            max_arg_len=max_arg_len,
+            arg_name=arg.name,
+            arg_num=arg_num,
+            arg_type=arg.datatype,
+            arg_default=arg_default
         )
 
-    def get_table_matches(self, suggestion, word_before_cursor):
+    def _make_cand(self, tbl, do_alias, suggestion, arg_mode=None):
+        """Returns a Candidate namedtuple.
+
+        :param tbl is a SchemaObject
+        :param arg_mode determines what type of arg list to suffix for
+        functions.
+        Possible values: call, signature
+
+        """
+        cased_tbl = tbl.name
+        if do_alias:
+            alias = self.alias(cased_tbl, suggestion.table_refs)
+        synonyms = (cased_tbl, generate_alias(cased_tbl))
+        maybe_alias = (' ' + alias) if do_alias else ''
+        maybe_schema = (tbl.schema + '.') if tbl.schema else ''
+        suffix = self._arg_list_cache[arg_mode][tbl.meta] if arg_mode else ''
+        if arg_mode == 'call':
+            display_suffix = self._arg_list_cache['call_display'][tbl.meta]
+        elif arg_mode == 'signature':
+            display_suffix = self._arg_list_cache['signature'][tbl.meta]
+        else:
+            display_suffix = ''
+        item = maybe_schema + cased_tbl + suffix + maybe_alias
+        display = maybe_schema + cased_tbl + display_suffix + maybe_alias
+        prio2 = 0 if tbl.schema else 1
+        return Candidate(item, synonyms=synonyms, prio2=prio2, display=display)
+
+    def get_table_matches(self, suggestion, word_before_cursor, alias=False):
         tables = self.populate_schema_objects(suggestion.schema, 'tables')
+        tables.extend(
+            SchemaObject(tbl.name) for tbl in suggestion.local_tables)
 
         # Unless we're sure the user really wants them, don't suggest the
         # pg_catalog tables that are implicitly on the search path
         if not suggestion.schema and (
                 not word_before_cursor.startswith('pg_')):
-            tables = [t for t in tables if not t.startswith('pg_')]
-
-        return self.find_matches(
-            word_before_cursor, tables, mode='strict', meta='table'
-        )
+            tables = [t for t in tables if not t.name.startswith('pg_')]
+        tables = [self._make_cand(t, alias, suggestion) for t in tables]
+        return self.find_matches(word_before_cursor, tables,
+                                 mode='strict', meta='table')
 
-    def get_view_matches(self, suggestion, word_before_cursor):
+    def get_view_matches(self, suggestion, word_before_cursor, alias=False):
         views = self.populate_schema_objects(suggestion.schema, 'views')
 
         if not suggestion.schema and (
                 not word_before_cursor.startswith('pg_')):
-            views = [v for v in views if not v.startswith('pg_')]
-
-        return self.find_matches(
-            word_before_cursor, views, mode='strict', meta='view'
-        )
+            views = [v for v in views if not v.name.startswith('pg_')]
+        views = [self._make_cand(v, alias, suggestion) for v in views]
+        return self.find_matches(word_before_cursor, views,
+                                 mode='strict', meta='view')
 
     def get_alias_matches(self, suggestion, word_before_cursor):
         aliases = suggestion.aliases
-        return self.find_matches(word_before_cursor, aliases, mode='strict',
-                                 meta='table alias')
+        return self.find_matches(word_before_cursor, aliases,
+                                 mode='strict', meta='table alias')
 
     def get_database_matches(self, _, word_before_cursor):
-        databases = []
-
-        query = render_template("/".join([self.sql_path, 'databases.sql']))
-        if self.conn.connected():
-            status, res = self.conn.execute_dict(query)
-            if status:
-                for record in res['rows']:
-                    databases.append(record['datname'])
-
-        return self.find_matches(word_before_cursor, databases, mode='strict',
-                                 meta='database')
+        return self.find_matches(word_before_cursor, self.databases,
+                                 mode='strict', meta='database')
 
-    def get_keyword_matches(self, _, word_before_cursor):
+    def get_keyword_matches(self, suggestion, word_before_cursor):
         return self.find_matches(word_before_cursor, self.keywords,
                                  mode='strict', meta='keyword')
 
     def get_datatype_matches(self, suggestion, word_before_cursor):
         # suggest custom datatypes
         types = self.populate_schema_objects(suggestion.schema, 'datatypes')
-        matches = self.find_matches(
-            word_before_cursor, types, mode='strict', meta='datatype')
-
+        types = [self._make_cand(t, False, suggestion) for t in types]
+        matches = self.find_matches(word_before_cursor, types,
+                                    mode='strict', meta='datatype')
         return matches
 
     def get_word_before_cursor(self, word=False):
@@ -418,6 +913,9 @@ class SQLAutoComplete(object):
             pass
 
     suggestion_matchers = {
+        FromClauseItem: get_from_clause_item_matches,
+        JoinCondition: get_join_condition_matches,
+        Join: get_join_matches,
         Column: get_column_matches,
         Function: get_function_matches,
         Schema: get_schema_matches,
